searchNodes=[{"doc":"MySQL driver for Elixir.","ref":"MyXQL.html","title":"MyXQL","type":"module"},{"doc":"Returns a supervisor child specification for a DBConnection pool.","ref":"MyXQL.html#child_spec/1","title":"MyXQL.child_spec/1","type":"function"},{"doc":"Closes a prepared query. Returns :ok on success, or raises an exception if there was an error. Options Options are passed to DBConnection.close/3 , see it's documentation for all available options.","ref":"MyXQL.html#close/3","title":"MyXQL.close/3","type":"function"},{"doc":"Executes a prepared query that returns a single result. Options Options are passed to DBConnection.execute/4 , see it's documentation for all available options. Examples iex&gt; { :ok , query } = MyXQL . prepare ( conn , &quot;&quot; , &quot;SELECT ? * ?&quot; ) iex&gt; { :ok , % MyXQL.Result { rows : [ row ] } } = MyXQL . execute ( conn , query , [ 2 , 3 ] ) iex&gt; row [ 6 ]","ref":"MyXQL.html#execute/4","title":"MyXQL.execute/4","type":"function"},{"doc":"Executes a prepared query that returns a single result. Returns %MyXQL.Result{} on success, or raises an exception if there was an error. See: execute/4 .","ref":"MyXQL.html#execute!/4","title":"MyXQL.execute!/4","type":"function"},{"doc":"Executes a prepared query that returns multiple results. Options Options are passed to DBConnection.execute/4 , see it's documentation for all available options. Examples iex&gt; { :ok , query } = MyXQL . prepare_many ( conn , &quot;&quot; , &quot;CALL multi_procedure()&quot; ) iex&gt; { :ok , [ % MyXQL.Result { rows : [ row1 ] } , % MyXQL.Result { rows : [ row2 ] } ] } = MyXQL . execute_many ( conn , query ) iex&gt; row1 [ 2 ] iex&gt; row2 [ 3 ]","ref":"MyXQL.html#execute_many/4","title":"MyXQL.execute_many/4","type":"function"},{"doc":"Executes a prepared query that returns multiple results. Returns [%MyXQL.Result{}] on success, or raises an exception if there was an error. See: execute_many/4 .","ref":"MyXQL.html#execute_many!/4","title":"MyXQL.execute_many!/4","type":"function"},{"doc":"Returns the configured JSON library. To customize the JSON library, include the following in your config/config.exs : config :myxql , json_library : SomeJSONModule Defaults to Jason .","ref":"MyXQL.html#json_library/0","title":"MyXQL.json_library/0","type":"function"},{"doc":"Prepares a query that returns a single result to be later executed. To execute the query, call execute/4 . To close the query, call close/3 . If a name is given, the name must be unique per query, as the name is cached. If a new statement uses an old name, the old statement will be closed. Options Options are passed to DBConnection.prepare/3 , see it's documentation for all available options. Examples iex&gt; { :ok , query } = MyXQL . prepare ( conn , &quot;&quot; , &quot;SELECT ? * ?&quot; ) iex&gt; { :ok , % MyXQL.Result { rows : [ row ] } } = MyXQL . execute ( conn , query , [ 2 , 3 ] ) iex&gt; row [ 6 ]","ref":"MyXQL.html#prepare/4","title":"MyXQL.prepare/4","type":"function"},{"doc":"Prepares a query that returns a single result. Returns %MyXQL.Query{} on success, or raises an exception if there was an error. See prepare/4 .","ref":"MyXQL.html#prepare!/4","title":"MyXQL.prepare!/4","type":"function"},{"doc":"Prepares and executes a query that returns a single result, in a single step. Options Options are passed to DBConnection.prepare_execute/4 , see it's documentation for all available options. Examples iex&gt; { :ok , _query , % MyXQL.Result { rows : [ row ] } } = MyXQL . prepare_execute ( conn , &quot;&quot; , &quot;SELECT ? * ?&quot; , [ 2 , 3 ] ) iex&gt; row [ 6 ]","ref":"MyXQL.html#prepare_execute/5","title":"MyXQL.prepare_execute/5","type":"function"},{"doc":"Prepares and executes a query that returns a single result, in a single step. Returns {%MyXQL.Query{}, %MyXQL.Result{}} on success, or raises an exception if there was an error. See: prepare_execute/5 .","ref":"MyXQL.html#prepare_execute!/5","title":"MyXQL.prepare_execute!/5","type":"function"},{"doc":"Prepares and executes a query that returns multiple results, in a single step. A prepared statement may return multiple results if it is a stored procedure. Any other type of prepared statement is not allowed to return multiple results and will return an error. Options Options are passed to DBConnection.prepare_execute/4 , see it's documentation for all available options. Examples iex&gt; { :ok , _ , [ % MyXQL.Result { rows : [ row1 ] } , % MyXQL.Result { rows : [ row2 ] } ] } = MyXQL . prepare_execute ( conn , &quot;&quot; , &quot;CALL multi_procedure()&quot; ) iex&gt; row1 [ 2 ] iex&gt; row2 [ 3 ]","ref":"MyXQL.html#prepare_execute_many/5","title":"MyXQL.prepare_execute_many/5","type":"function"},{"doc":"Prepares and executes a query that returns multiple results, in a single step. Returns {%MyXQL.Queries{}, [%MyXQL.Result{}]} on success, or raises an exception if there was an error. See: prepare_execute_many/5 .","ref":"MyXQL.html#prepare_execute_many!/5","title":"MyXQL.prepare_execute_many!/5","type":"function"},{"doc":"Prepares a query that returns multiple results to be later executed. A prepared statement may return multiple results if it is a stored procedure. Any other type of prepared statement is not allowed to return multiple results and will return an error. To execute the query, call execute_many/4 . To close the query, call close/3 . If a name is given, the name must be unique per query, as the name is cached. If a new statement uses an old name, the old statement will be closed. Options Options are passed to DBConnection.prepare/3 , see it's documentation for all available options. Examples iex&gt; { :ok , query } = MyXQL . prepare_many ( conn , &quot;&quot; , &quot;CALL multi_procedure()&quot; ) iex&gt; { :ok , [ % MyXQL.Result { rows : [ row1 ] } , % MyXQL.Result { rows : [ row2 ] } ] } = MyXQL . execute_many ( conn , query , [ 2 , 3 ] ) iex&gt; row1 [ 2 ] iex&gt; row2 [ 3 ]","ref":"MyXQL.html#prepare_many/4","title":"MyXQL.prepare_many/4","type":"function"},{"doc":"Prepares a query that returns multiple results. Returns %MyXQL.Queries{} on success, or raises an exception if there was an error. See prepare_many/4 .","ref":"MyXQL.html#prepare_many!/4","title":"MyXQL.prepare_many!/4","type":"function"},{"doc":"Runs a query that returns a single result. Text queries and prepared statements MyXQL supports MySQL's two ways of executing queries: text protocol - queries are sent as text binary protocol - used by prepared statements The query statement is still sent as text, however it may contain placeholders for parameter values. Prepared statements have following benefits: better performance: less overhead when parsing the query by the DB engine better performance: binary protocol for encoding parameters and decoding result sets is more efficient protection against SQL injection attacks The drawbacks of prepared statements are: not all statements are preparable requires two roundtrips to the DB server: one for preparing the statement and one for executing it. This can be alleviated by holding on to prepared statement and executing it multiple times. Options :query_type - Use :binary for binary protocol (prepared statements), :binary_then_text to attempt executing a binary query and if that fails fallback to executing a text query, and :text for text protocol (default: :binary ). :cache_statement - Caches the query with the given name. If the cache statement name is reused with a different statement, the previous query is automatically closed. Options are passed to DBConnection.execute/4 for text protocol, and DBConnection.prepare_execute/4 for binary protocol. See their documentation for all available options. Examples iex&gt; MyXQL . query ( conn , &quot;CREATE TABLE posts (id serial, title text)&quot; ) { :ok , % MyXQL.Result { } } iex&gt; MyXQL . query ( conn , &quot;INSERT INTO posts (title) VALUES (&#39;title 1&#39;)&quot; ) { :ok , % MyXQL.Result { last_insert_id : 1 , num_rows : 1 } } iex&gt; MyXQL . query ( conn , &quot;INSERT INTO posts (title) VALUES (?)&quot; , [ &quot;title 2&quot; ] ) { :ok , % MyXQL.Result { last_insert_id : 2 , num_rows : 1 } }","ref":"MyXQL.html#query/4","title":"MyXQL.query/4","type":"function"},{"doc":"Runs a query that returns a single result. Returns %MyXQL.Result{} on success, or raises an exception if there was an error. See query/4 .","ref":"MyXQL.html#query!/4","title":"MyXQL.query!/4","type":"function"},{"doc":"Runs a query that returns multiple results. A query may return multiple results if it is a text query with statements separated by semicolons or a stored procedure. Any prepared statement that is not a stored procedure is not allowed to return multiple results and will return an error. For more information on text queries and prepared statements, see query/4 . Options :query_type - Use :binary for binary protocol (prepared statements), :binary_then_text to attempt executing a binary query and if that fails fallback to executing a text query, and :text for text protocol (default: :binary ). :cache_statement - Caches the query with the given name. If the cache statement name is reused with a different statement, the previous query is automatically closed. Options are passed to DBConnection.execute/4 for text protocol, and DBConnection.prepare_execute/4 for binary protocol. See their documentation for all available options. Examples iex&gt; MyXQL . query_many ( conn , &quot;SELECT 1; SELECT 2;&quot; , [ ] , query_type : :text ) { :ok , [ % MyXQL.Result { rows : [ [ 1 ] ] } , % MyXQL.Result { rows : [ [ 2 ] ] } ] }","ref":"MyXQL.html#query_many/4","title":"MyXQL.query_many/4","type":"function"},{"doc":"Runs a query that returns multiple results. Returns [%MyXQL.Result{}] on success, or raises an exception if there was an error. See query_many/4 .","ref":"MyXQL.html#query_many!/4","title":"MyXQL.query_many!/4","type":"function"},{"doc":"Rollback a transaction, does not return. Aborts the current transaction. If inside multiple transaction/3 functions, bubbles up to the top level. Example { :error , :oops } = MyXQL . transaction ( pid , fn conn -&gt; MyXQL . rollback ( conn , :oops ) IO . puts &quot;never reaches here!&quot; end )","ref":"MyXQL.html#rollback/2","title":"MyXQL.rollback/2","type":"function"},{"doc":"Starts the connection process and connects to a MySQL server. Options :protocol - Set to :socket for using UNIX domain socket, or :tcp for TCP (default: :socket ) Connecting using UNIX domain socket is the preferred method. If :hostname or :port is set, protocol defaults to :tcp unless :socket is set too. :socket - Connect to MySQL via UNIX domain socket in the given path (default: MYSQL_UNIX_PORT env variable, then &quot;/tmp/mysql.sock&quot; ) :socket_options - Options to be given to the underlying socket, applies to both TCP and UNIX sockets. See :gen_tcp.connect/3 for more information. (default: [] ) :hostname - Server hostname (default: MYSQL_HOST env variable, then &quot;localhost&quot; ) :port - Server port (default: MYSQL_TCP_PORT env variable, then 3306 ) :database - Database (default: nil ) :username - Username (default: USER env variable) :password - Password (default: MYSQL_PWD env variable, then nil ) :charset - A connection charset. On connection handshake, the charset is set to utf8mb4 , but if this option is set, an additional SET NAMES &lt;charset&gt; [COLLATE &lt;collation&gt;] query will be executed after establishing the connection. COLLATE will be added if :collation is set. (default: nil ) :collation - A connection collation. Must be given with :charset option, and if set it overwrites the default collation for the given charset. (default: nil ) :ssl - Set to true if SSL should be used (default: false ) :ssl_opts - A list of SSL options, see :ssl.connect/2 (default: [] ) :connect_timeout - Socket connect timeout in milliseconds (default: 15_000 ) :handshake_timeout - Connection handshake timeout in milliseconds (default: 15_000 ) :ping_timeout - Socket receive timeout when idle in milliseconds (default: 15_000 ). See DBConnection.ping/1 for more information :prepare - How to cache prepared queries. Queries can be named or unnamed. Named queries are cached, unnamed queries are never cache by default. The possible values for this option are: :named - cache only named queries :unnamed - treat all queries as unnamed (i.e. nothing is ever cached) :force_named - treat all queries as named (i.e. everything is cached) Note that MySQL has a global limit on the number of prepared queries. So if you enable :force_named in production, you may cache more queries than allowed by MySQL, leading to disconnections and user errors. Use :force_named only in a controlled environment, such as :test , and in :prod only if you are monitoring the prepare statement count of your databases (such as using a dashboard or setting alarm handlers) :disconnect_on_error_codes - List of error code integers or atoms that when encountered will disconnect the connection. See &quot;Disconnecting on Errors&quot; section below for more information. The given options are passed down to DBConnection, some of the most commonly used ones are documented below: :after_connect - A function to run after the connection has been established, either a 1-arity fun, a {module, function, args} tuple, or nil (default: nil ) :pool - The pool module to use, defaults to built-in pool provided by DBconnection :pool_size - The size of the pool See DBConnection.start_link/2 for more information and a full list of available options. Examples Start connection using the default configuration (UNIX domain socket): iex&gt; { :ok , pid } = MyXQL . start_link ( [ ] ) { :ok , # PID &lt; 0 . 69 . 0 &gt; } Start connection over TCP: iex&gt; { :ok , pid } = MyXQL . start_link ( protocol : :tcp ) { :ok , # PID &lt; 0 . 69 . 0 &gt; } Run a query after connection has been established: iex&gt; { :ok , pid } = MyXQL . start_link ( after_connect : &amp; MyXQL . query! ( &amp;1 , &quot;SET time_zone = &#39;+00:00&#39;&quot; ) ) { :ok , # PID &lt; 0 . 69 . 0 &gt; } Disconnecting on errors Sometimes the connection becomes unusable. For example, services such as AWS Aurora support failover which means the database you are currently connected to may suddenly become read-only. An attempt to do any write operation, such as INSERT/UPDATE/DELETE will lead to errors such as: ** (MyXQL.Error) (1792) (ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION) Cannot execute statement in a READ ONLY transaction. Luckily, you can instruct MyXQL to disconnect in such cases by using the following configuration: disconnect_on_error_codes : [ :ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION ] This cause the connection process to attempt to reconnect according to the backoff configuration. MyXQL automatically disconnects the connection on the following error codes and they don't have to be configured: :ER_MAX_PREPARED_STMT_COUNT_REACHED You can pass error codes as integers too: disconnect_on_error_codes : [ 1792 ] Error codes MyXQL maintains a mapping of integers/atoms for commonly used errors. You can add additional ones by adding the following compile-time configuration: config :myxql , :extra_error_codes , [ { 1048 , :ER_BAD_NULL_ERROR } ] After adding the configuration, MyXQL needs to be recompiled. It can be done with: $ mix deps.clean myxql --build To convert error code integers to names you can use perror command-line utility that ships with MySQL client installation, e.g.: bash $ perror 1792 MySQL error code 1792 ( ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION ) : Cannot execute statement in a READ ONLY transaction .","ref":"MyXQL.html#start_link/1","title":"MyXQL.start_link/1","type":"function"},{"doc":"Returns a stream for a query on a connection. Stream consumes memory in chunks of at most max_rows rows (see Options). This is useful for processing large datasets. A stream must be wrapped in a transaction and may be used as an Enumerable . Options :max_rows - Maximum numbers of rows in a result (default: 500 ) Options are passed to DBConnection.stream/4 , see it's documentation for other available options. Examples { :ok , results } = MyXQL . transaction ( pid , fn conn -&gt; stream = MyXQL . stream ( conn , &quot;SELECT * FROM integers&quot; , [ ] , max_rows : max_rows ) Enum . to_list ( stream ) end ) Suppose the integers table contains rows: 1, 2, 3, 4 and max_rows is set to 2 . We'll get following results: # The first item is result of executing the query and has no rows data Enum . at ( results , 0 ) #=&gt; %MyXQL.Result{num_rows: 0, ...} # The second item is result of fetching rows 1 &amp; 2 Enum . at ( results , 1 ) #=&gt; %MyXQL.Result{num_rows: 2, rows: [[1], [2]]} # The third item is result of fetching rows 3 &amp; 4 Enum . at ( results , 2 ) #=&gt; %MyXQL.Result{num_rows: 2, rows: [[3], [4]]} Because the total number of fetched rows happens to be divisible by our chosen max_rows , there might be more data on the server so another fetch attempt is made. Because in this case there weren't any more rows, the final result has 0 rows: Enum . at ( results , 3 ) #=&gt; %MyXQL.Result{num_rows: 0} However, if the table contained only 3 rows, the 3rd result would contain: Enum . at ( results , 2 ) #=&gt; %MyXQL.Result{num_rows: 1, rows: [[3]]} And that would be the last result in the stream.","ref":"MyXQL.html#stream/4","title":"MyXQL.stream/4","type":"function"},{"doc":"Acquire a lock on a connection and run a series of requests inside a transaction. The result of the transaction fun is return inside an :ok tuple: {:ok, result} . To use the locked connection call the request with the connection reference passed as the single argument to the fun . If the connection disconnects all future calls using that connection reference will fail. rollback/2 rolls back the transaction and causes the function to return {:error, reason} . transaction/3 can be nested multiple times if the connection reference is used to start a nested transaction. The top level transaction function is the actual transaction. Options Options are passed to DBConnection.transaction/3 , see it's documentation for all available options. Examples { :ok , result } = MyXQL . transaction ( pid , fn conn -&gt; MyXQL . query! ( conn , &quot;SELECT title FROM posts&quot; ) end )","ref":"MyXQL.html#transaction/3","title":"MyXQL.transaction/3","type":"function"},{"doc":"","ref":"MyXQL.html#t:conn/0","title":"MyXQL.conn/0","type":"type"},{"doc":"","ref":"MyXQL.html#t:option/0","title":"MyXQL.option/0","type":"type"},{"doc":"","ref":"MyXQL.html#t:query_option/0","title":"MyXQL.query_option/0","type":"type"},{"doc":"","ref":"MyXQL.html#t:start_option/0","title":"MyXQL.start_option/0","type":"type"},{"doc":"","ref":"MyXQL.html#t:stream_option/0","title":"MyXQL.stream_option/0","type":"type"},{"doc":"A struct for a prepared statement that returns multiple results. An example use case is a stored procedure with multiple SELECT statements. Its public fields are: :name - The name of the prepared statement; :num_params - The number of parameter placeholders; :statement - The prepared statement Named and Unnamed Queries Named queries are identified by the non-empty value in :name field and are meant to be re-used. Unnamed queries, with :name equal to &quot;&quot; , are automatically closed after being executed.","ref":"MyXQL.Queries.html","title":"MyXQL.Queries","type":"module"},{"doc":"","ref":"MyXQL.Queries.html#t:t/0","title":"MyXQL.Queries.t/0","type":"type"},{"doc":"A struct for a prepared statement that returns a single result. For the struct returned from a query that returns multiple results, see MyXQL.Queries . Its public fields are: :name - The name of the prepared statement; :num_params - The number of parameter placeholders; :statement - The prepared statement Named and Unnamed Queries Named queries are identified by the non-empty value in :name field and are meant to be re-used. Unnamed queries, with :name equal to &quot;&quot; , are automatically closed after being executed.","ref":"MyXQL.Query.html","title":"MyXQL.Query","type":"module"},{"doc":"","ref":"MyXQL.Query.html#t:t/0","title":"MyXQL.Query.t/0","type":"type"},{"doc":"Result struct returned from any successful query. Its public fields are: :columns - The column names; :connection_id - The connection ID; :last_insert_id - The ID of the last inserted row; :num_rows - The number of fetched or affected rows; :rows - The result set. A list of lists, each inner list corresponding to a row, each element in the inner list corresponds to a column; :num_warnings - The number of warnings Warnings Depending on SQL MODE, a given query may error or just return warnings. If result.num_warnings is non-zero it means there were warnings and they can be retrieved by making another query: MyXQL . query! ( conn , &quot;SHOW WARNINGS&quot; )","ref":"MyXQL.Result.html","title":"MyXQL.Result","type":"module"},{"doc":"","ref":"MyXQL.Result.html#t:t/0","title":"MyXQL.Result.t/0","type":"type"},{"doc":"","ref":"MyXQL.Error.html","title":"MyXQL.Error","type":"exception"},{"doc":"","ref":"MyXQL.Error.html#t:t/0","title":"MyXQL.Error.t/0","type":"type"},{"doc":"MySQL driver for Elixir. Documentation: http://hexdocs.pm/myxql","ref":"readme.html","title":"MyXQL","type":"extras"},{"doc":"Automatic decoding and encoding of Elixir values to and from MySQL text and binary protocols Supports transactions, prepared queries, streaming, pooling and more via DBConnection Supports MySQL 5.5+, 8.0, and MariaDB 10.3 Supports mysql_native_password , sha256_password , and caching_sha2_password authentication plugins","ref":"readme.html#features","title":"MyXQL - Features","type":"extras"},{"doc":"Add :myxql to your dependencies: def deps ( ) do [ { :myxql , &quot;~&gt; 0.5.0&quot; } ] end Make sure you are using the latest version! iex&gt; { :ok , pid } = MyXQL . start_link ( username : &quot;root&quot; ) iex&gt; MyXQL . query! ( pid , &quot;CREATE DATABASE IF NOT EXISTS blog&quot; ) iex&gt; { :ok , pid } = MyXQL . start_link ( username : &quot;root&quot; , database : &quot;blog&quot; ) iex&gt; MyXQL . query! ( pid , &quot;CREATE TABLE posts IF NOT EXISTS (id serial primary key, title text)&quot; ) iex&gt; MyXQL . query! ( pid , &quot;INSERT INTO posts (`title`) VALUES (&#39;Post 1&#39;)&quot; ) % MyXQL.Result { columns : nil , connection_id : 11204 , , last_insert_id : 1 , num_rows : 1 , num_warnings : 0 , rows : nil } iex&gt; MyXQL . query ( pid , &quot;INSERT INTO posts (`title`) VALUES (?), (?)&quot; , [ &quot;Post 2&quot; , &quot;Post 3&quot; ] ) % MyXQL.Result { columns : nil , connection_id : 11204 , last_insert_id : 2 , num_rows : 2 , num_warnings : 0 , rows : nil } iex&gt; MyXQL . query ( pid , &quot;SELECT * FROM posts&quot; ) { :ok , % MyXQL.Result { columns : [ &quot;id&quot; , &quot;title&quot; ] , connection_id : 11204 , last_insert_id : nil , num_rows : 3 , num_warnings : 0 , rows : [ [ 1 , &quot;Post 1&quot; ] , [ 2 , &quot;Post 2&quot; ] , [ 3 , &quot;Post 3&quot; ] ] } } It's recommended to start MyXQL under supervision tree: defmodule MyApp.Application do use Application def start ( _type , _args ) do children = [ { MyXQL , username : &quot;root&quot; , name : :myxql } ] Supervisor . start_link ( children , opts ) end end and then we can refer to it by its :name : iex&gt; MyXQL . query! ( :myxql , &quot;SELECT NOW()&quot; ) . rows [ [ ~N[2018-12-28 13:42:31] ] ]","ref":"readme.html#usage","title":"MyXQL - Usage","type":"extras"},{"doc":"See Mariaex Compatibility page for transition between drivers.","ref":"readme.html#mariaex-compatibility","title":"MyXQL - Mariaex Compatibility","type":"extras"},{"doc":"MySQL Elixir -- -- - -- -- -- NULL nil bool 1 | 0 int 42 float 42.0 decimal # Decimal &lt; 42.0 &gt; # (1) date ~D[2013-10-12] # (2) time ~T[00:37:14] # (3) datetime ~N[2013-10-12 00:37:14] # (2), (4) timestamp ~U[2013-10-12 00:37:14Z] # (2), (4) json %{ &quot;foo&quot; =&gt; &quot;bar&quot; } # (5) char &quot;é&quot; text &quot;myxql&quot; binary &lt;&lt; 1 , 2 , 3 &gt;&gt; bit &lt;&lt; 1 :: size ( 1 ) , 0 :: size ( 1 ) &gt;&gt; point , polygon , ... % Geo.Point { coordinates : { 0.0 , 1.0 } } , ... # (6) Notes: See Decimal When using SQL mode that allows them, MySQL &quot;zero&quot; dates and datetimes are represented as :zero_date and :zero_datetime respectively. Values that are negative or greater than 24:00:00 cannot be decoded Datetime fields are represented as NaiveDateTime , however a UTC DateTime can be used for encoding as well MySQL added a native JSON type in version 5.7.8, if you're using earlier versions, remember to use TEXT column for your JSON field. See &quot;Geometry support&quot; section below","ref":"readme.html#data-representation","title":"MyXQL - Data representation","type":"extras"},{"doc":"MyXQL comes with JSON support via the Jason library. To use it, add :jason to your dependencies: { :jason , &quot;~&gt; 1.0&quot; } You can customize it to use another library via the :json_library configuration: config :myxql , :json_library , SomeJSONModule","ref":"readme.html#json-support","title":"MyXQL - JSON support","type":"extras"},{"doc":"MyXQL comes with Geometry types support via the Geo package. To use it, add :geo to your dependencies: { :geo , &quot;~&gt; 3.3&quot; } Note, some structs like %Geo.PointZ{} does not have equivalent on the MySQL server side and thus shouldn't be used. If you're using MyXQL geometry types with Ecto and need to for example accept a WKT format as user input, consider implementing an custom Ecto type .","ref":"readme.html#geometry-support","title":"MyXQL - Geometry support","type":"extras"},{"doc":"Run tests: git clone git @github . com :elixir - ecto / myxql . git cd myxql mix deps . get mix test See scripts/test-versions.sh for scripts used to test against different server versions.","ref":"readme.html#contributing","title":"MyXQL - Contributing","type":"extras"},{"doc":"The source code is under Apache License 2.0. Copyright (c) 2018 Plataformatec Copyright (c) 2020 Dashbit Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"MyXQL - License","type":"extras"}]